Gecode::ValSelFunction< View > Class Template Reference

User-defined value selection. More...

`#include <val-sel.hpp>`

## Public Types

typedef ValSel< View, typenameBranchTraits< typenameView::VarType >::ValType >::Val | Val
| The corresponding value type.
typedef BranchTraits< Var >::Val | ValFunction
| The corresponding value function.
Public Types inherited from Gecode::ValSel< View, BranchTraits< View::VarType >::ValType >
typedef View | View
| View type.
typedef View::VarType | Var
| Corresponding variable type.
typedef BranchTraits< View::VarType >::ValType | Val
| Value type.

## Public Member Functions

| ValSelFunction (Space &home, const ValBranch< Var > &vb)
| Constructor for initialization.
| ValSelFunction (Space &home, ValSelFunction< View > &vs)
| Constructor for cloning.
Val | val (const Space &home, View x, int i)
| Return user-defined value of view x at position i.
bool | notice (void) const
| Whether dispose must always be called (that is, notice is needed).
void | dispose (Space &home)
| Delete value selection.
Public Member Functions inherited from Gecode::ValSel< View, BranchTraits< View::VarType >::ValType >
| ValSel (Space &home, const ValBranch< Var > &vb)
| Constructor for initialization.
bool | notice (void) const
| Whether dispose must always be called (that is, notice is needed).
void | dispose (Space &home)
| Delete value selection.

## Protected Attributes

SharedData< ValFunction > | v
| The user-defined value function.

## Detailed Description

template<class View>
class Gecode::ValSelFunction< View >

User-defined value selection.

Definition at line 65 of file val-sel.hpp.

## Member Typedef Documentation

## Val

template<class View>

typedef ValSel<View,typenameBranchTraits<typenameView::VarType>::ValType>::Val Gecode::ValSelFunction< View >::Val

The corresponding value type.

Definition at line 74 of file val-sel.hpp.

## ValFunction

template<class View>

typedef BranchTraits<Var>::Val Gecode::ValSelFunction< View >::ValFunction

The corresponding value function.

Definition at line 76 of file val-sel.hpp.

## Constructor & Destructor Documentation

## ValSelFunction() [1/2]

template<class View>

Gecode::ValSelFunction< View >::ValSelFunction | ( | Space & | home,
|  | const ValBranch< Var > & | vb )

Constructor for initialization.

## ValSelFunction() [2/2]

template<class View>

Gecode::ValSelFunction< View >::ValSelFunction | ( | Space & | home,
|  | ValSelFunction< View > & | vs )

inline

Constructor for cloning.

Definition at line 123 of file val-sel.hpp.

## Member Function Documentation

## val()

template<class View>

ValSelFunction< View >::Val Gecode::ValSelFunction< View >::val | ( | const Space & | home,
|  | View | x,
|  | int | i )

inline

Return user-defined value of view x at position i.

Definition at line 128 of file val-sel.hpp.

## notice()

template<class View>

bool Gecode::ValSelFunction< View >::notice | ( | void |  | ) | const

inline

Whether dispose must always be called (that is, notice is needed).

Definition at line 135 of file val-sel.hpp.

## dispose()

template<class View>

void Gecode::ValSelFunction< View >::dispose | ( | Space & | home | ) |

inline

Delete value selection.

Definition at line 140 of file val-sel.hpp.

## Member Data Documentation

## v

template<class View>

SharedData<ValFunction> Gecode::ValSelFunction< View >::v

protected

The user-defined value function.

Definition at line 79 of file val-sel.hpp.

The documentation for this class was generated from the following file:

- gecode/kernel/branch/val-sel.hpp